// TuBEditor.cpp

#include <afxwin.h>
#include "TuBEditor.h"
#include "Fenster.h"
#include "DocWnd.h"
#include "Text.h"
#include "Schrift.h"
#include "Grafik.h"
#include "Bild.h"
#include "Linie.h"

BEGIN_MESSAGE_MAP(CAnwendung, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

CAnwendung theApp;

BOOL CAnwendung::InitInstance()
{
	CWinApp::InitInstance();
	SetRegistryKey(_T("Beispiele zum Buch"));
	OSVERSIONINFO version;
	version.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	GetVersionEx(&version);
	CString temp;
	temp.Format("%lu.%lu.%u ", version.dwMajorVersion,
				version.dwMinorVersion,
				LOWORD(version.dwBuildNumber));
	WriteProfileString("Allgemein","OSVersion",temp);
	LoadStdProfileSettings(4);
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(IDR_TextdokumentTYPE,
		RUNTIME_CLASS(CText),
		RUNTIME_CLASS(CDocWnd),
		RUNTIME_CLASS(CSchrift));
	AddDocTemplate(pDocTemplate);
	pDocTemplate = new CMultiDocTemplate(IDR_GrafikdokumentTYPE,
		RUNTIME_CLASS(CGrafik),
		RUNTIME_CLASS(CDocWnd),
		RUNTIME_CLASS(CBild));
	AddDocTemplate(pDocTemplate);
	pDocTemplate = new CMultiDocTemplate(IDR_LiniedokumentTYPE,
		RUNTIME_CLASS(CGrafik),
		RUNTIME_CLASS(CDocWnd),
		RUNTIME_CLASS(CLinie));
	AddDocTemplate(pDocTemplate);
	CFenster* pMainFrame = new CFenster;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;
	m_pMainWnd->DragAcceptFiles();
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	return TRUE;
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	enum { IDD = IDD_ABOUTBOX };
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAnwendung::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


