// Bild.cpp

#include <afxwin.h>
#include "TuBEditor.h"
#include "Grafik.h"
#include "Bild.h"

IMPLEMENT_DYNCREATE(CBild, CView)

CBild::CBild()
{
	last.SetRectEmpty();
}

BEGIN_MESSAGE_MAP(CBild, CView)
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

void CBild::OnDraw(CDC* pDC)
{
	CGrafik* pDoc = GetDocument();
	pDC->FillSolidRect(pDoc->m_ObenLinks.x,pDoc->m_ObenLinks.y,
		pDoc->m_UntenRechts.x - pDoc->m_ObenLinks.x,
		pDoc->m_UntenRechts.y - pDoc->m_ObenLinks.y,
		RGB(0,0,255));
}

void CBild::OnLButtonDown(UINT nFlags, CPoint point)
{
	CGrafik* pDoc = GetDocument();
	CClientDC Tafel(this);
	OnPrepareDC(&Tafel,NULL);
	Tafel.DPtoLP(&point);
	pDoc->m_ObenLinks = point;
	SetCapture();
	CView::OnLButtonDown(nFlags, point);
}

void CBild::OnLButtonUp(UINT nFlags, CPoint point)
{
	CGrafik* pDoc = GetDocument();
	CClientDC Tafel(this);
	OnPrepareDC(&Tafel,NULL);
	Tafel.DPtoLP(&point);
	if (GetCapture() == this)
	{
		pDoc->m_UntenRechts = point;
		InvalidateRect(NULL);
		pDoc->UpdateAllViews(this);
		UpdateWindow();
		ReleaseCapture();
		last.SetRectEmpty();
	}
	CView::OnLButtonUp(nFlags, point);
}

void CBild::OnMouseMove(UINT nFlags, CPoint point)
{
	CGrafik* pDoc = GetDocument();
	if (GetCapture() == this)
	{
		CClientDC Tafel(this);
                CPoint p = pDoc->m_ObenLinks;
                OnPrepareDC(&Tafel,NULL);
                Tafel.LPtoDP(&p);
		CRect temp(p,point);
		Tafel.DrawDragRect(temp,CSize(1,1),last,CSize(1,1));
		last.SetRect(p.x,
                             p.y,
                             point.x,
                             point.y);
	}
	CView::OnMouseMove(nFlags, point);
}

BOOL CBild::OnPreparePrinting(CPrintInfo* pInfo)
{
     return DoPreparePrinting(pInfo);
}

void CBild::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo)
{
	pDC->SetMapMode(MM_LOMETRIC);
         CView::OnPrepareDC(pDC, pInfo);
}

