// Schrift.cpp

#include <afxwin.h>
#include <afxext.h>
#include "TuBEditor.h"
#include "Text.h"
#include "Schrift.h"

IMPLEMENT_DYNCREATE(CSchrift, CView)

BEGIN_MESSAGE_MAP(CSchrift, CView)
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
	ON_WM_CHAR()
END_MESSAGE_MAP()

void CSchrift::OnDraw(CDC* pDC)
{
	CText* pDoc = GetDocument();
	pDC->TextOut(1,1,pDoc->Puffer);	//(2)
}

BOOL CSchrift::OnPreparePrinting(CPrintInfo* pInfo)
{
     pInfo->SetMaxPage(2);
     return DoPreparePrinting(pInfo);
}

void CSchrift::OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	pFont = new CFont;
	pFont->CreatePointFont(200,"Arial",pDC);
}

void CSchrift::OnEndPrinting(CDC* pDC, CPrintInfo* pInfo)
{
	delete pFont;
}

void CSchrift::OnPrepareDC(CDC* pDC, CPrintInfo* pInfo)
{
	pDC->SetMapMode(MM_LOMETRIC);
        if (pInfo != NULL && pInfo->m_nCurPage > 1)
	{
		pDC->SelectObject(pFont);
	}
         CView::OnPrepareDC(pDC, pInfo);
}

void CSchrift::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	CString temp;				//(1)
	CText* pDoc = GetDocument();	//(2)
	if (nChar >=32 && nChar <=127)	//(3)
		{
			temp.Format("%c",nChar);	//(4)
			pDoc->Puffer+=temp;	//(5)
			pDoc->UpdateAllViews(this);	//(6)
			InvalidateRect(NULL);	//(7)
			UpdateWindow();	//(8)
		}
	CView::OnChar(nChar, nRepCnt, nFlags);
}

void CSchrift::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint)
{
   Invalidate();
}

void CSchrift::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{
    if (pInfo->m_nCurPage == 1)
    {
       pDC->SetTextAlign(TA_CENTER);
       pDC->TextOut(pInfo->m_rectDraw.right/2,
		pInfo->m_rectDraw.bottom/2,
		GetDocument()->GetTitle());
    }
    else
    {
	Kopfzeile(pDC,pInfo,GetDocument()->GetTitle());
	Fusszeile(pDC,pInfo,_T("Demodruck"));
       	pDC->SetWindowOrg(pInfo->m_rectDraw.left,
			-pInfo->m_rectDraw.top);
	pDC->SetTextAlign(TA_LEFT | TA_TOP
			 | TA_NOUPDATECP);
        OnDraw(pDC);
    }
}

void CSchrift::Kopfzeile(CDC* pDC, CPrintInfo* pInfo,
			CString& KText)
{
	pDC->SetTextAlign(TA_LEFT);
	pDC->TextOut(0,0,KText);
	TEXTMETRIC tm;
	pDC->GetTextMetrics(&tm);
	pDC->MoveTo(pInfo->m_rectDraw.left,
      		pInfo->m_rectDraw.top - tm.tmHeight-30);
	pDC->LineTo(pInfo->m_rectDraw.right,
      		pInfo->m_rectDraw.top - tm.tmHeight-30);
       	pInfo->m_rectDraw.top-=tm.tmHeight+30+30;
}

void CSchrift::Fusszeile(CDC* pDC, CPrintInfo* pInfo, CString& FText)
{
	TEXTMETRIC tm;
	CString seite;
	seite.Format("Seite -%i-",
			pInfo->m_nCurPage);
	pDC->SetTextAlign(TA_LEFT | TA_BOTTOM);
	pDC->TextOut(pInfo->m_rectDraw.left,
		pInfo->m_rectDraw.bottom,FText);
	pDC->SetTextAlign(TA_RIGHT | TA_BOTTOM);
	pDC->TextOut(pInfo->m_rectDraw.right,
		pInfo->m_rectDraw.bottom,seite);
	pDC->GetTextMetrics(&tm);
	pDC->MoveTo(pInfo->m_rectDraw.left,
		pInfo->m_rectDraw.bottom+tm.tmHeight+30);
	pDC->LineTo(pInfo->m_rectDraw.right,
		pInfo->m_rectDraw.bottom+tm.tmHeight+30);
	pInfo->m_rectDraw.bottom+=tm.tmHeight+30+30;
}

