// Editor.cpp

#include <afxwin.h>
#include "Editor.h"
#include "Fenster.h"
#include "Daten.h"
#include "Ansicht.h"
#include "DocWnd.h"

BEGIN_MESSAGE_MAP(CAnwendung, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
END_MESSAGE_MAP()

CAnwendung theApp;

BOOL CAnwendung::InitInstance()
{
	CWinApp::InitInstance();
	SetRegistryKey(_T("Beispiele zum Buch"));
	LoadStdProfileSettings(4);
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_EditorTYPE,
		RUNTIME_CLASS(CDaten),
		RUNTIME_CLASS(CDocWnd),
		RUNTIME_CLASS(CAnsicht));
	AddDocTemplate(pDocTemplate);
	CFenster* pMainFrame = new CFenster;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;
	m_pMainWnd->DragAcceptFiles();
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	m_pMainWnd->DragAcceptFiles();
	return TRUE;
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	enum { IDD = IDD_ABOUTBOX };
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAnwendung::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}



